#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>


/* h5common, (c) by T. Mueller, 2002 */
/* Stand: 23.5.2002 */

int fileExists(char *path, char *file) {
	char *tmpnam;
	FILE *fil;
	int namlang;
	int ret;

	ret=0;

	namlang=0;
	namlang+=strlen(path);
	namlang++;     /* / */
	namlang+=strlen(file);
	namlang++;     /* NULL */

	tmpnam=malloc(namlang);
	if(tmpnam == NULL)
		return;
	if(file[0] != (char)NULL)
		snprintf(tmpnam,(size_t)namlang,"%s/%s",path,file);
	else
		snprintf(tmpnam,(size_t)namlang,"%s",path);

	fil=fopen(tmpnam,"r");
	if(fil != (FILE *)NULL) {
		ret=1;	
		fclose(fil);
	}

	free(tmpnam);
	return(ret);
}		

int isDir(char *path, char *file) {
	DIR *dir;
  char *tmpnam;
  int namlang;

  namlang=0;
  namlang+=strlen(path);
  namlang++;     /* / */
  namlang+=strlen(file);
  namlang++;     /* NULL */

  tmpnam=malloc(namlang);
  if(tmpnam == NULL)
    return;

	if(file[0] != (char)NULL)
		snprintf(tmpnam,(size_t)namlang,"%s/%s",path,file);
	else
		snprintf(tmpnam,(size_t)namlang,"%s",path);

	dir=opendir(tmpnam);
	if(dir == (DIR *)NULL) {
		free(tmpnam);
		return(0);
	} else {
		closedir(dir);
		free(tmpnam);
		return(1);
	}
}

int hexDec(char *hex) {
  int ret;
  int pos;

  ret=0;
  pos=0;
  while(pos < 2) {
    ret*=16;
    switch(*hex) {
      case '0':
      break;
      case '1':
        ret+=1;
      break;
      case '2':
        ret+=2;
      break;
      case '3':
        ret+=3;
      break;
      case '4':
        ret+=4;
      break;
      case '5':
        ret+=5;
      break;
      case '6':
        ret+=6;
      break;
      case '7':
        ret+=7;
      break;
      case '8':
        ret+=8;
      break;
      case '9':
        ret+=9;
      break;
      case 'A':
      case 'a':
        ret+=10;
      break;
      case 'B':
      case 'b':
        ret+=11;
      break;
      case 'C':
      case 'c':
        ret+=12;
      break;
      case 'D':
      case 'd':
        ret+=13;
      break;
      case 'E':
      case 'e':
        ret+=14;
      break;
      case 'F':
      case 'f':
        ret+=15;
      break;
    }
    hex++;
    pos++;
  }
  return(ret);
}

void query2String(char *string) {
	char *z1,*z2;
	
	z1=string;

	while(*z1 != (char)NULL) {	
		while((*z1 != '%') && (*z1 != (char)NULL))
			z1++;
	
		if(*z1 == '%') {
			*z1=hexDec(z1+1);
			z2=z1+3;
			while(*z2 != (char)NULL) {
				*(z2-2)=*z2;
				z2++;
			}
			*(z2-2)=(char)NULL;
		}	
	}		
}		

void queryOut(char *string) {
	char *z1;
	
	z1=string;	
	while(*z1 != (char)NULL) {
		switch(*z1) {
			case ' ':
			case '':
			case '':
			case '':
			case '':
			case '':
			case '':
			case '':			
				printf("%c%X",'%',*z1);
			break;
			default:
				putchar(*z1);
			break;	
		}
		z1++;		
	}		
}		

void printFile(char *path, char *file) {
	char *tmpnam;
	FILE *fil;
	int namlang;
	int i1;

	namlang=0;
	namlang+=strlen(path);
	namlang++;     /* / */
	namlang+=strlen(file);
	namlang++;     /* NULL */

	tmpnam=malloc(namlang);
	if(tmpnam == NULL)
		return;	
	if(file[0] != (char)NULL)
		snprintf(tmpnam,(size_t)namlang,"%s/%s",path,file);
	else
		snprintf(tmpnam,(size_t)namlang,"%s",path);	

	fil=fopen(tmpnam,"r");
	if(fil != (FILE *)NULL) {
		i1=fgetc(fil);
		while(i1 != EOF) {
			putchar(i1);
			i1=fgetc(fil);
		}	
		fclose(fil);		
	}		

	free(tmpnam);
}		

void printHeader(void) {
	printf("Content-type: text/html\n\n");
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n");	
	printFile(HEADER,"");
}

void printFooter(void) {
	printFile(FOOTER,"");	
}

