#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>


/* h5fdown, (c) by T. Mueller, 2002 */
/* Stand: 04.6.2002 */

#define DATAPATH "/export/unix-ag/soft/data"
#define NEWIMAGEURL "/gif/new.gif"
#define HPIMGURL "/gif/home.gif"
#define NHPIMGURL "/gif/nohome.gif"
#define SHOTIMGURL "/gif/shot.gif"
#define NSHOTIMGURL "/gif/noshot.gif"
#define DLIMGURL "/gif/disk.gif"
#define NDLIMGURL "/gif/nodisk.gif"
#define NOIMAGEURL "/stud/soft/pics/keinbild.jpg"
#define HEADER "/export/unix-ag/soft/templates/head"
#define FOOTER "/export/unix-ag/soft/templates/foot"

#define INFOFILE "info"
#define H5DOWNEXT "h5d"

#define DBC "#cfd1cf" /* Directory BorderColor */
#define DBG "#FFFFFF" /* Directory Background */
#define DFG "#9c9e9c" /* Directory Foreground */
#define HBC "#ff9f0f" /* Head Border Color */
#define HBG "#efeea7" /* Head Background */
#define HFG "#156b08" /* Head Foreground */
#define CBC "#838483" /* Category Border Color */
#define CBG "#dee0de" /* Category Background */
#define CFG "#000000" /* Category Foreground */
#define DLBC "blue"    /* Download Border Color */
#define DLBG "orange"  /* Download Background */
#define DLFG "black"   /* Download Foreground Color */	

#define BORDERSIZE 4
#define STEPSIZE 2
#define THUMBSIZE 100	/* Thumbnail size */
#define DTW 600		/* Download Table width */
#define WIDTH "600"	/* Table width (as String: "600", "100%") */

#define NEW "Neu"
#define NOTITLE "Titel unbekannt"
#define DL "[D]"
#define HP "[H]"
#define SS "[S]"

#define TARGET "newwin"

#define HOME "Start"

/********************************/
/* NOTHING TO CHANGE BELOW HERE */
/********************************/

#define MAXPATH 256
#define MAXLINE 256

#include "h5common.c"

int getLine(FILE *file, char *string, int maxlang, int fisch) {
	int i1,count;
	char *z1;

	z1=string;
	count=0;
	i1=fgetc(file);

	if(fisch == 1) {	/* Fishing for spaces */
		while((i1 != EOF) && (i1 != 0xa) && (i1 == ' ')) {
			i1=fgetc(file);
		}
	}

	while((i1 != EOF) && (i1 != 0xa) && (count < (maxlang-1))) {
		*z1=(char)i1;
		z1++;
		count++;
		i1=fgetc(file);
			
	}
	if((count >= maxlang-1) && (i1 != 0xa)) {
		fseek(file,ftell(file)-1,SEEK_SET);
		count=maxlang;
	}
	*z1=(char)NULL;
	if(i1 == EOF)
		count=-1;
	return(count);
}

int getValue(FILE *datei, char *name, char *tmp, int lang) {
	char tmpline[MAXLINE+1];
	int ct;
	char *z1;

	rewind(datei);

	ct=getLine(datei,tmpline,MAXLINE,1);
	while(ct > 0) {
		if(strstr(tmpline,name) == tmpline) {
			z1=tmpline;
			z1+=strlen(name);
			while(*z1 != ':') {
				if(*z1 != (char)NULL) {
					z1++;
				}
				else {
					*tmp=(char)NULL;
					return(0);
				}
			}
			if(*z1 == ':')
				z1++;
			while(*z1 == ' ') {
				z1++;
			}
			strncpy(tmp,z1,(size_t)lang);
			return(1);
		}
		ct=getLine(datei,tmpline,MAXLINE,1);
	}
	*tmp=(char)NULL;
	return(0);
}

int getDescr(FILE *datei, int line, char *tmp, int lang) {
	char tmpline[MAXLINE+1];
	int ct,i1;
	char *z1;
	
	rewind(datei);
	
	ct=getLine(datei,tmpline,MAXLINE,0);
	while(ct > 0) {
		if(strstr(tmpline,"---") == tmpline) {
			for(i1=0; (i1<=line) && (ct >= 0); i1++) {
				ct=getLine(datei,tmpline,MAXLINE,0);				
			}
			if(ct >= 0) {
				z1=tmpline;	
				strncpy(tmp,z1,(size_t)lang);
				if(ct == MAXLINE)
					return(2);
				else
					return(1);
			}	
			else {
				*tmp=(char)NULL;
				return(0);
			}
		}	
		ct=getLine(datei,tmpline,MAXLINE,0);
	}
	*tmp=(char)NULL;
	return(0);
}


void genPage(char *page) {
	DIR *dir;
	struct dirent *entrys;
	char *path;
	int pathlang;
	char *z1,*z2,*z3;
	int i1,i2,stufe,hasshot;
	int flg;
	FILE *file;
	char tmpfile[MAXPATH+1];
	char tmpline[MAXLINE+1];
	char c1,c2;	

	pathlang=0;
	pathlang+=strlen(DATAPATH);
	pathlang++;		/* / */
	pathlang+=strlen(page);
	pathlang++;		/* NULL */

	path=malloc(pathlang);
	if(path == NULL)
		return;

	snprintf(path,(size_t)pathlang,"%s/%s",DATAPATH,page);
	query2String(path);

	if(strchr(page,'.') != (char *)NULL)
		return;		
	if(strchr(page,';') != (char *)NULL)
		return;	
	if(strchr(page,'>') != (char *)NULL)
		return;
	if(strchr(page,'<') != (char *)NULL)
		return;
	if(strchr(page,'|') != (char *)NULL)
		return;	
	if(page[0] == '/')
		return;	
	if(strlen(getenv("SCRIPT_NAME")) == 0)
		return;	
	
	/* Directory - View */
	if(page[0] != (char)NULL) {
		printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"%s\">\n",DBC,WIDTH);	
		printf("<tr><td width=\"100%c\">\n",'%');
		printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');	
		printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",DBG,'%');	
		printf("<a href=\"%s\"><font color=\"%s\">%s</font></a><br>",getenv("SCRIPT_NAME"),DFG,HOME);
	
		z1=path;
		z1+=strlen(DATAPATH);
		z3=z1;
		z2=strchr(z1,'/');
		stufe=1;
		while(z2 != (char *)NULL) {
			z1=z2+1;
			z2=strchr(z1,'/');
			if(z2 != (char *)NULL) {
				for(i1=0; i1<stufe*STEPSIZE; i1++)	
					printf("&nbsp;");
				*z2=(char)NULL;
				printf("<font color=\"%s\"><a href=\"%s?PAGE=",DFG,getenv("SCRIPT_NAME"));
				queryOut(z3+1);
			
				printf("\">%s</a></font><br>\n",z1);	
			
				*z2='/';
				stufe++;
			}		
		}
		printf("</td></tr></table></td></tr></table><br>\n");
	}	

	/* Info */	
	if((fileExists(path,INFOFILE) == 1) || (page[0] != (char)NULL)) {	
		printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"%s\">\n",HBC,WIDTH);
		printf("<tr><td width=\"100%c\">\n",'%');	
		printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');
		printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",HBG,'%');	
		if(page[0] != (char)NULL)	
			printf("<font size=+2 color=\"%s\"><b>%s</b></font><br>",HFG,z1);

		printf("<font color=\"%s\">\n",HFG);
		printFile(path,INFOFILE);
		printf("</font>\n");
		printf("</td></tr></table></td></tr></table><BR>\n");		
	}
	/* Category - View */
	flg=0;	
	dir=opendir(path);
	if(dir == (DIR *)NULL)
		return;
	entrys=readdir(dir);
	while(entrys != (struct dirent *)NULL) {
		if(isDir(path,entrys->d_name) == 1) {
			if(entrys->d_name[0] != '.') {
				if(flg == 0) {
					printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"%s\">\n",CBC,WIDTH);
					printf("<tr><td width=\"100%c\">\n",'%');
					printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');
					printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",CBG,'%');
					printf("<ul>\n");

					flg=1;
				}		
				printf("<LI><a href=\"%s?PAGE=",getenv("SCRIPT_NAME"));	
				if(page[0] != (char)NULL) {
					queryOut(page);
					putchar('/');
				}	
				queryOut(entrys->d_name);
				printf("\"><font color=\"%s\">%s</font></a></LI>\n",CFG,entrys->d_name);		
			}
		}	
		entrys=readdir(dir);
	}
	closedir(dir);	
	if(flg==1)
		printf("</td></tr></table></td></tr></table><br><hr>\n");

	/* Downloads */
	stufe=0;
	dir=opendir(path);
	if(dir == (DIR *)NULL)
		return;
	entrys=readdir(dir);
	while(entrys != (struct dirent *)NULL) {
		if(isDir(path,entrys->d_name) != 1) {
			if(entrys->d_name[0] != '.') {
				z1=strchr(entrys->d_name,'.');
				if(z1 != NULL) {
					z1++;
					if(strcmp(z1,H5DOWNEXT) == 0) {
						snprintf(tmpfile,(size_t)MAXPATH,"%s/%s",path,entrys->d_name);
						file=fopen(tmpfile,"r");
						if(file != (FILE *)NULL) {
							*(z1-1)=(char)NULL;
							printf("<a name=\"%s\">\n",entrys->d_name);
							*(z1-1)='.';
							printf("<table border=\"0\" bgcolor=\"%s\" width=\"%i\" cellspacing=\"0\" cellpadding=\"0\">\n",DLBC,DTW);
							printf("<tr><td bgcolor=\"%s\">",DLBC);
							printf("<table border=\"0\" bgcolor=\"%s\" width=\"%i\" cellspacing=\"%i\" cellpadding=\"4\">\n",DLBC,DTW,BORDERSIZE);
							printf("<tr>\n");
							printf("<td width=\"100%c\" bgcolor=\"%s\" colspan=\"3\"><b><font color=\"%s\">\n",'%',DLBG,DLFG);
							z1=tmpline;
							i1=getValue(file,"NAME",z1,MAXLINE);
							if(i1 != 0)
								printf("%s",z1);
							else
								printf("%s",NOTITLE);
							printf("</font></b>");
							z1=strrchr(entrys->d_name,'.');
							if(z1 != (char *)NULL) {
								z1++;
								if(*z1 != (char)NULL) {
									c1=*z1;
									*z1='n';
									z1++;
									c2=*z1;
									*z1=(char)NULL;
									if(fileExists(path,entrys->d_name) == 1)
										printf(" <img src=\"%s\" alt=\"%s\" border=0>",NEWIMAGEURL,NEW);
									*z1=c2;
									z1--;
									*z1=c1;
								}
							}
							printf("</td>\n");
							printf("<td bgcolor=\"%s\" colspan=\"3\" align=right>",DLBG);
							z1=tmpline;
							i1=getValue(file,"VERSION",z1,MAXLINE);	
							if(i1 != 0)
								printf("<font color=\"%s\">%s</font>",DLFG,z1);
							else
								printf("&nbsp;&nbsp;&nbsp;");
							printf("</td>\n");
							printf("</tr>\n\n");
							printf("<tr>\n");
							printf("<td bgcolor=\"%s\" rowspan=\"2\" align=right>",DLBG);
							hasshot=0;
							z1=tmpline;
							i1=getValue(file,"SHOT",z1,MAXLINE);
							if(i1 == 0)
								i1=getValue(file,"SCREENSHOT",z1,MAXLINE);
							if(i1 != 0) {
								printf("<a target=%s href=\"%s\">",TARGET,z1);	
								hasshot=1;	
							}
							z1=tmpline;
							i1=getValue(file,"THUMB",z1,MAXLINE);
							if(i1 == 0)
								 i1=getValue(file,"THUMBNAIL",z1,MAXLINE);
							if(i1 == 0) {
								printf("<img alt=\" \" border=\"0\" src=\"%s\" width=\"%i\">",NOIMAGEURL,THUMBSIZE);
							}
							else {
								printf("<img alt=\" \" width=\"%i\" border=\"0\" src=\"%s\">",THUMBSIZE,z1);
							}
							if(hasshot == 1)
								printf("</a>\n");
							else
								printf("\n");
							printf("</td>\n");
							printf("<td valign=top height=\"*\" width=\"100%c\" bgcolor=\"%s\" colspan=\"5\">\n",'%',DLBG);
							printf("<font color=\"%s\">",DLFG);
							i1=0;
							z1=tmpline;
							i2=getDescr(file,i1,z1,MAXLINE);
							while(i2 != 0) {
								printf("%s",z1);
								if(i2 == 1)
									putchar(' ');
								i1++;
								i2=getDescr(file,i1,z1,MAXLINE);
							}
							printf("</font>\n");
							printf("</td>\n");
							printf("</tr>\n\n");
							printf("<tr>\n");
							printf("<td height=\"100%c\" bgcolor=\"%s\" width=\"100%c\">",'%',DLBG,'%');
							z1=tmpline;
							i1=getValue(file,"STATUS",z1,MAXLINE);
							if(i1 != 0) 
								printf("<font color=\"%s\">%s</font>",DLFG,z1);
							else
								printf("&nbsp;&nbsp;&nbsp;");		
							printf("</td>\n");
							printf("<td bgcolor=\"%s\">",DLBG);
							z1=tmpline;
							i1=getValue(file,"SIZE",z1,MAXLINE);
							if(i1 != 0)
								printf("<font color=\"%s\">%s</font>",DLFG,z1);
							else
								printf("&nbsp;&nbsp;&nbsp;");
							printf("</td>\n");
							printf("<td bgcolor=\"%s\">",DLBG);
							z1=tmpline;
							i1=getValue(file,"SHOT",z1,MAXLINE);
							if(i1 == 0)
								i1=getValue(file,"SCREENSHOT",z1,MAXLINE);
							if(i1 == 0) {
								printf("<img align=center border=0 alt=\"%s\" src=\"%s\">\n","&nbsp;",NSHOTIMGURL);
							}
							else {
								printf("<a target=%s href=\"%s\">",TARGET,z1);
								printf("<img align=center border=0 alt=\"%s\" src=\"%s\">",SS,SHOTIMGURL);
								printf("</a>\n");
							}
							printf("</td>\n");
							printf("<td bgcolor=\"%s\">",DLBG);
							z1=tmpline;
							i1=getValue(file,"DOWN",z1,MAXLINE);
							if(i1 == 0)
								i1=getValue(file,"DOWNLOAD",z1,MAXLINE);
							if(i1 == 0) {
								printf("<img align=center border=0 alt=\"%s\" src=\"%s\"></td>\n","&nbsp;",NDLIMGURL);
							}
							else {
								printf("<a target=%s href=\"%s\">",TARGET,z1);
								printf("<img align=center border=0 alt=\"%s\" src=\"%s\"></td>\n",DL,DLIMGURL);
								printf("</a>\n");
							}	
							printf("<td bgcolor=\"%s\">",DLBG);
							z1=tmpline;
							i1=getValue(file,"HOME",z1,MAXLINE);
							if(i1 == 0)
								i1=getValue(file,"HOMEPAGE",z1,MAXLINE);
							if(i1 == 0) {
								printf("<img align=center border=0 alt=\"%s\" src=\"%s\"></td>\n",HP,NHPIMGURL);
							}
							else {
								printf("<a target=%s href=\"%s\">",TARGET,z1);
								printf("<img align=center border=0 alt=\"%s\" src=\"%s\"></td>\n",HP,HPIMGURL);
								printf("</a>\n");
							}
							
							printf("</tr>\n");
							printf("</table>\n");
							printf("</td></tr></table><br>\n");
							fclose(file);
						}

					}
				}
			}	
		}
		entrys=readdir(dir);
	}	
	
	closedir(dir);
	
	free(path);
	
}		

int main(void) {
	char *z1;
	char *query;
	
	printHeader();

	query=getenv("QUERY_STRING");	
	if(strlen(query) == 0) {
		genPage("");
	}	
	else {
		z1=strstr(query,"PAGE");	
		if(z1 != (char *)NULL) {
			z1+=4;
			if(*z1 == '=')
				genPage(z1+1);
		}		
	}		

	printFooter();

	return(0);
}	
