#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>


/* h5faq, (c) by T. Mueller, 2002 */
/* Stand: 04.6.2002 */

#define DATAPATH "/export/unix-ag/faq/data"
#define QUESTIMGURL "/gif/quest.gif"
#define ANSWERIMGURL "/gif/answer.gif"
#define NEWIMAGEURL "/gif/new.gif"
#define HEADER "/export/unix-ag/faq/templates/head"
#define FOOTER "/export/unix-ag/faq/templates/foot"

#define INFOFILE "info"

#define QBG "#e0e0e0" /* Question Background */
#define QFG "#cf1010" /* Question Foreground */
#define QBC "#000000" /* Question Border */
#define QOBG "#dddddd" /* Question Overview Background */
#define QOFG "#cf1010" /* Question Overview Foreground */
#define QOBC "#000000" /* Question Overview Border */
#define ABG "#FFFFFF" /* Answer Background */
#define AFG "#0000c5" /* Answer Foreground */
#define DBC "#cfd1cf" /* Directory BorderColor */
#define DBG "#FFFFFF" /* Directory Background */
#define DFG "#9c9e9c" /* Directory Foreground */
#define HBC "#ff9f0f" /* Head Border Color */
#define HBG "#efeea7" /* Head Background */
#define HFG "#156b08" /* Head Foreground */
#define CBC "#838483" /* Category Border Color */
#define CBG "#dee0de" /* Category Background */
#define CFG "#000000" /* Category Foreground */

#define BORDERSIZE 4

#define STEPSIZE 2

#define NEW "Neu"

#define HOME "Start"

/********************************/
/* NOTHING TO CHANGE BELOW HERE */
/********************************/

#include "h5common.c"

void genPage(char *page) {
	DIR *dir;
	struct dirent *entrys;
	char *path;
	int pathlang;
	char *z1,*z2,*z3;
	int i1,stufe;
	int flg;

	pathlang=0;
	pathlang+=strlen(DATAPATH);
	pathlang++;		/* / */
	pathlang+=strlen(page);
	pathlang++;		/* NULL */

	path=malloc(pathlang);
	if(path == NULL)
		return;

	snprintf(path,(size_t)pathlang,"%s/%s",DATAPATH,page);
	query2String(path);

	if(strchr(page,'.') != (char *)NULL)
		return;		
	if(strchr(page,';') != (char *)NULL)
		return;	
	if(strchr(page,'>') != (char *)NULL)
		return;
	if(strchr(page,'<') != (char *)NULL)
		return;
	if(strchr(page,'|') != (char *)NULL)
		return;	
	if(page[0] == '/')
		return;	
	if(strlen(getenv("SCRIPT_NAME")) == 0)
		return;	
	
	/* Directory - View */
	if(page[0] != (char)NULL) {
		printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%c\">\n",DBC,'%');	
		printf("<tr><td width=\"100%c\">\n",'%');
		printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');	
		printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",DBG,'%');	
		printf("<a href=\"%s\"><font color=\"%s\">%s</font></a><br>",getenv("SCRIPT_NAME"),DFG,HOME);
	
		z1=path;
		z1+=strlen(DATAPATH);
		z3=z1;
		z2=strchr(z1,'/');
		stufe=1;
		while(z2 != (char *)NULL) {
			z1=z2+1;
			z2=strchr(z1,'/');
			if(z2 != (char *)NULL) {
				for(i1=0; i1<stufe*STEPSIZE; i1++)	
					printf("&nbsp;");
				*z2=(char)NULL;
				printf("<font color=\"%s\"><a href=\"%s?PAGE=",DFG,getenv("SCRIPT_NAME"));
				queryOut(z3+1);
			
				printf("\">%s</a></font><br>\n",z1);	
			
				*z2='/';
				stufe++;
			}		
		}
		printf("</td></tr></table></td></tr></table><br>\n");
	}	

	/* Info */	
	if((fileExists(path,INFOFILE) == 1) || (page[0] != (char)NULL)) {
		printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%c\">\n",HBC,'%');
		printf("<tr><td width=\"100%c\">\n",'%');	
		printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');
		printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",HBG,'%');	
		if(page[0] != (char)NULL)	
			printf("<font size=+2 color=\"%s\"><b>%s</b></font><br>",HFG,z1);

		printf("<font color=\"%s\">\n",HFG);
		printFile(path,INFOFILE);
		printf("</font>\n");
		printf("</td></tr></table></td></tr></table><BR>\n");		
	}
	/* Category - View */
	flg=0;	
	dir=opendir(path);
	if(dir == (DIR *)NULL)
		return;
	entrys=readdir(dir);
	while(entrys != (struct dirent *)NULL) {
		if(isDir(path,entrys->d_name) == 1) {
			if(entrys->d_name[0] != '.') {
				if(flg == 0) {
					printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%c\">\n",CBC,'%');
					printf("<tr><td width=\"100%c\">\n",'%');
					printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');
					printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",CBG,'%');
					printf("<ul>\n");

					flg=1;
				}		
				printf("<LI><a href=\"%s?PAGE=",getenv("SCRIPT_NAME"));	
				if(page[0] != (char)NULL) {
					queryOut(page);
					putchar('/');
				}	
				queryOut(entrys->d_name);
				printf("\"><font color=\"%s\">%s</font></a></LI>\n",CFG,entrys->d_name);		
			}
		}	
		entrys=readdir(dir);
	}
	closedir(dir);	
	if(flg==1)
		printf("</td></tr></table></td></tr></table><br><hr>\n");

	/* Question - List */
	flg=0;
	stufe=0;
	dir=opendir(path);
	if(dir == (DIR *)NULL)
		return;
	entrys=readdir(dir);
	while(entrys != (struct dirent *)NULL) {
		if(isDir(path,entrys->d_name) != 1) {
			z1=strrchr(entrys->d_name,'.');
			if(z1 != (char *)NULL) {
				if(*(z1+1) == 'q') {		
					if(flg==0) {
						flg=1;
						printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%c\">\n",QOBC,'%');
						printf("<tr><td width=\"100%c\">\n",'%');
						printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');
						printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",QOBG,'%');
					}
					*z1=(char)NULL;
					printf("<a name=\"top_%s\"></a><table border=\"0\"><tr><td bgcolor=\"%s\"><img src=\"%s\" border=0 alt=\"?\"></td><td bgcolor=\"%s\" width=\"100%c\"><a href=\"%c%s\"><font color=\"%s\">",entrys->d_name,QOBG,QUESTIMGURL,QOBG,'%','#',entrys->d_name,QOFG);
					*z1='.';
					printFile(path,entrys->d_name);
					*(z1+1) = 'n';
					if(fileExists(path,entrys->d_name) == 1) {
						printf(" <img src=\"%s\" border=0 alt=\"%s\">",NEWIMAGEURL,NEW);
					}
					*(z1+1) = 'q';			
					printf("</font></a></td></tr></table>\n");
					stufe++;
				}
			}	
		}
		entrys=readdir(dir);
	}
	closedir(dir);	
	if(flg == 1) {
		printf("</td></tr></table></td></tr></table>\n");
		printf("<br><HR><br>\n");
	}	
	
	/* Questions and Answers */
	stufe=0;
	dir=opendir(path);
	if(dir == (DIR *)NULL)
		return;
	entrys=readdir(dir);
	while(entrys != (struct dirent *)NULL) {
		if(isDir(path,entrys->d_name) != 1) {
			z1=strrchr(entrys->d_name,'.');
			if(z1 != (char *)NULL) {
				if(*(z1+1) == 'q') {
					*z1=(char)NULL;
					printf("<a name=\"%s\"></a>\n",entrys->d_name);					
					printf("<table bgcolor=\"%s\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%c\">\n",QBC,'%');
					printf("<tr><td width=\"100%c\">\n",'%');
					printf("<table border=\"0\" cellpadding=\"4\" cellspacing=\"%i\" width=\"100%c\">\n",BORDERSIZE,'%');

					printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",QBG,'%');
					printf("<table border=\"0\">\n"); 
					printf("<tr><td bgcolor=\"%s\" valign=top><img src=\"%s\" border=\"0\" alt=\"?\"></td><td>\n",QBG,QUESTIMGURL);
					printf("<a href=\"%ctop_%s\"><font color=\"%s\">",'#',entrys->d_name,QFG);
					*z1='.';
			
					printFile(path,entrys->d_name);
					*(z1+1) = 'n';
					if(fileExists(path,entrys->d_name) == 1) {
						printf(" <img src=\"%s\" border=0 alt=\"%s\">",NEWIMAGEURL,NEW);
					}
					*(z1+1) = 'q';
					printf("</font></a></td></tr></table></td></tr>\n");
					*(z1+1)='a';

					printf("<tr><td bgcolor=\"%s\" width=\"100%c\">\n",ABG,'%');					
					printf("<table border=\"0\">\n");
					printf("<tr><td bgcolor=\"%s\" valign=top><img src=\"%s\" border=\"0\" alt=\"!\"></td><td>\n",ABG,ANSWERIMGURL);
					
					printf("<font color=\"%s\">",AFG);	
	
					printFile(path,entrys->d_name);
					printf("</font></td></tr></table></td></tr></table></td></tr></table><br>\n");
					*(z1+1)='q';
					stufe++;
				}
			}
		}
		entrys=readdir(dir);
	}	
	
	closedir(dir);
	
	free(path);
	
}		

int main(void) {
	char *z1;
	char *query;
	
	printHeader();

	query=getenv("QUERY_STRING");	
	if(strlen(query) == 0) {
		genPage("");
	}	
	else {
		z1=strstr(query,"PAGE");	
		if(z1 != (char *)NULL) {
			z1+=4;
			if(*z1 == '=')
				genPage(z1+1);
		}		
	}		

	printFooter();

	return(0);
}	
