#include <gtk/gtk.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include "info.xpm"
#include "error.xpm"
#include "myfault.xpm"
#include "warn.xpm"

#define WINDOWTYPE GTK_WINDOW_TOPLEVEL /* GTK_WINDOW_TOPLEVEL | GTK_WINDOW_DIALOG | GTK_WINDOW_POPUP */
#define FRAMETYPE GTK_SHADOW_ETCHED_OUT /* GTK_SHADOW_NONE | GTK_SHADOW_IN | GTK_SHADOW_OUT | GTK_SHADOW_ETCHED_IN | GTK_SHADOW_ETCHED_OUT */
#define TOPLABEL "Benutzermenue der Datenstation H5 des RRZN, vers. 0.2a, (c) by T.Mueller, 2000"
#define SUBLABEL "Bitte auswhlen"
#define TITEL "H5-Menue"
#define BACKBUTTON "Zurck"
#define MENBUTTON "Hauptmen"
#define DISCBUTTON "Lesen !!!"
#define DISKETTE "Diskette"
#define FLOPPYTITLE "Diskette..."
#define VIEW "ansehen"
#define DELBUTTON "lschen"
#define FORMBUTTON "formatieren"
#define BUTTON_OK "Ok"
#define NODISCTEXT "No disclaimer found !"
#define WAIT "Bitte warten !"
#define UNBEDINGTLESEN "Unbedingt lesen !!!"
#define FLOPPY "a:"
#define DEV_FLOPPY "fd0H1440"
#define SYS_DEL "/usr/bin/mformat "FLOPPY
#define SYS_FORMAT "/usr/bin/fdformat /dev/"DEV_FLOPPY
#define SYS_COPY "/usr/bin/mcopy"
#define SYS_DD "/bin/dd"
#define SYS_DIR "/usr/bin/mdir"
#define ERROR_DEL "Ich konnte die Diskette nicht lschen !"
#define ERROR_FORMAT1 "Fehler 1 beim Formatieren der Diskette !"
#define ERROR_FORMAT2 "Fehler 2 beim Formatieren der Diskette !"
#define ERROR_COPY "Fehler beim kopieren der Daten !"
#define ERROR_DIR "Ich kann die Diskette nicht ansehen !"
#define MESSAGE_TITLE "Information"
#define ERROR_TITLE "Fehler"
#define MYFAULT_TITLE "Uuups..."
#define WARNING_TITLE "Warnung"
#define SPECTITLE NULL
#define DOWNTITLE NULL
#define MAINHORZ 800
#define MAINVERT 600
#define OUTFRAME 20
#define INFRAME 20
#define BUTTONSPACINGH 3
#define BUTTONSPACINGV 3
#define MAXPATH 256
#define MAXENTRYS 50
#define MAXLINE 256
#define DISCH 400
#define DISCV 200
#define DIRINONECOLUMN TRUE
#define DIALOGSPACINGS 5

#define DEBUG TRUE

extern void addDirButtons(void);
extern void destroyButtons(void);
extern void addDownDirButtons(int);
extern void addImageButtons(int);
extern void addExecButtons(int);

char path[MAXPATH+1];
char startpath[MAXPATH+1];
char names[MAXENTRYS][MAXPATH];
int entryAnz;
GtkWidget *mainWindow,*discWin;
GtkWidget *buttHBox,*subVBox1;
GtkWidget *leftBox,*rightBox,*middleBox;
GtkWidget *backButton, *menButton;
GtkWidget *floppyFrame;
GtkWidget *dialog;
GtkWidget *subFrame;
GtkWidget *downFrame;

void quick_message(gchar *message, int which, int with_ok)
{
	int i1;
        GtkWidget  *label, *okay_button, *pixmapwid, *vbox, *hbox;
        GdkPixmap *pixmap;
        GdkBitmap *mask;
        GtkStyle *style;

        while (gtk_events_pending())
                gtk_main_iteration();

        dialog = gtk_dialog_new();
        gtk_window_set_modal(GTK_WINDOW(dialog),TRUE);
        gtk_window_set_position(GTK_WINDOW(dialog),GTK_WIN_POS_CENTER);
        gtk_window_activate_default(GTK_WINDOW(dialog));

	if(with_ok)
	{
        	okay_button = gtk_button_new_with_label(BUTTON_OK);
        	gtk_signal_connect_object (GTK_OBJECT (okay_button), "clicked",GTK_SIGNAL_FUNC (gtk_widget_destroy), (gpointer)dialog);
        	gtk_container_add (GTK_CONTAINER (GTK_DIALOG(dialog)->action_area), okay_button);
	}
        vbox=gtk_vbox_new(FALSE,0);
        hbox=gtk_hbox_new(FALSE,0);
        gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, DIALOGSPACINGS);
	while (gtk_events_pending())
                gtk_main_iteration();

        switch(which)
        {
                case 1:         /*--- Info ---*/
                        gtk_window_set_title(GTK_WINDOW(dialog),MESSAGE_TITLE);
                        style = gtk_widget_get_style(dialog);
                        pixmap = gdk_pixmap_create_from_xpm_d(mainWindow->window,  &mask, &style->bg[GTK_STATE_NORMAL], (gchar **)pixmap_info );
                        pixmapwid = gtk_pixmap_new( pixmap, mask );
                        gtk_box_pack_start(GTK_BOX(hbox), pixmapwid, FALSE, FALSE, DIALOGSPACINGS);
                break;
                case 2:         /*--- Error ---*/
                        gtk_window_set_title(GTK_WINDOW(dialog),ERROR_TITLE);
                        style = gtk_widget_get_style(dialog);
                        pixmap = gdk_pixmap_create_from_xpm_d(mainWindow->window,  &mask, &style->bg[GTK_STATE_NORMAL], (gchar **)pixmap_error );
                        pixmapwid = gtk_pixmap_new( pixmap, mask );
                        gtk_box_pack_start(GTK_BOX(hbox), pixmapwid, FALSE, FALSE, DIALOGSPACINGS);
                break;
                case 3:         /*--- MyFault ---*/
                        gtk_window_set_title(GTK_WINDOW(dialog),MYFAULT_TITLE);
                        style = gtk_widget_get_style(dialog);
                        pixmap = gdk_pixmap_create_from_xpm_d(mainWindow->window,  &mask, &style->bg[GTK_STATE_NORMAL], (gchar **)pixmap_myfault );
                        pixmapwid = gtk_pixmap_new( pixmap, mask );
                        gtk_box_pack_start(GTK_BOX(hbox), pixmapwid, FALSE, FALSE, DIALOGSPACINGS);
                break;
                case 4:         /*--- Warning ---*/
                        gtk_window_set_title(GTK_WINDOW(dialog),WARNING_TITLE);
                        style = gtk_widget_get_style(dialog);
                        pixmap = gdk_pixmap_create_from_xpm_d(mainWindow->window,  &mask, &style->bg[GTK_STATE_NORMAL], (gchar **)pixmap_warn );
                        pixmapwid = gtk_pixmap_new( pixmap, mask );
                        gtk_box_pack_start(GTK_BOX(hbox), pixmapwid, FALSE, FALSE, DIALOGSPACINGS);
                break;
                default:
                        if(DEBUG)
                                printf("Unknown Quick-message !\n");
			exit(-1);
                break;
        }

        label = gtk_label_new (message);
        gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, DIALOGSPACINGS);
	while (gtk_events_pending())
                gtk_main_iteration();
        gtk_container_add (GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), vbox);
	while (gtk_events_pending())
                gtk_main_iteration();
        gtk_widget_show_all (dialog);
	sleep(1);
	for(i1=0;i1<500;i1++)
	{
		while (gtk_events_pending())
                	gtk_main_iteration();
	}
}


int isGoodDir(char *testpath)
{
        DIR *dir;
        dir=opendir(testpath);
        if(dir == (DIR *)NULL)
        {
                return(0);
        }
        else
        {
                closedir(dir);
                return(1);
        }
}

int isGoodFile(char *testpath)
{
        FILE *file;
    file=fopen(testpath,"r");
    if(file == (FILE *)NULL)
    {
        return(0);
    }
    else
    {
        fclose(file);
        return(1);
    }
}


void destroyDisc(GtkWidget *widget,gpointer data)
{
        if(DEBUG)
                printf("Disc-Window destroyed !\n");
        gtk_window_set_modal(GTK_WINDOW(discWin),FALSE);
        gtk_window_set_modal(GTK_WINDOW(mainWindow),TRUE);

        gtk_widget_destroy(discWin);
} 

void DiscBox(int aufgebohrt)
{
        GtkWidget *mainVBox,*mainHBox,*vbox,*hbox,*mainFrame,*hbox2;
        GtkWidget *button1,*text,*vscrollbar,*table;
	char tmppath[2*MAXPATH+1];
	FILE *file;
	int i1;
	char c1[2];

        if(DEBUG)
                printf("Showing Disclaimer-Dialog\n");
        discWin=gtk_window_new(GTK_WINDOW_DIALOG);
        gtk_window_set_position(GTK_WINDOW(discWin),GTK_WIN_POS_CENTER);
        gtk_window_set_policy(GTK_WINDOW(discWin),0,0,0);
        gtk_window_set_modal(GTK_WINDOW(discWin),TRUE);
        gtk_window_set_modal(GTK_WINDOW(mainWindow),FALSE);
        gtk_signal_connect(GTK_OBJECT(discWin),"delete_event",GTK_SIGNAL_FUNC(destroyDisc),NULL);

        mainVBox=gtk_vbox_new(FALSE,0);
        gtk_container_add(GTK_CONTAINER(discWin),mainVBox);
        gtk_widget_show(mainVBox);

        mainHBox=gtk_hbox_new(FALSE,0);
        gtk_box_pack_start(GTK_BOX(mainVBox),mainHBox,FALSE,FALSE,DIALOGSPACINGS);
        gtk_widget_show(mainHBox);

        mainFrame=gtk_frame_new(NULL);
        gtk_box_pack_start(GTK_BOX(mainHBox),mainFrame,FALSE,FALSE,DIALOGSPACINGS);
        gtk_widget_show(mainFrame);

        /* Box */
        hbox=gtk_hbox_new(FALSE,DIALOGSPACINGS);
        gtk_container_add(GTK_CONTAINER(mainFrame), hbox);
        gtk_widget_show(hbox);
        vbox=gtk_vbox_new(FALSE,0);
        gtk_box_pack_start(GTK_BOX(hbox),vbox,FALSE,FALSE,DIALOGSPACINGS);
        gtk_widget_show(vbox);


	/* TextBox */
	table = gtk_table_new (2, 2, FALSE);
	gtk_table_set_row_spacing (GTK_TABLE (table), 0, 2);
	gtk_table_set_col_spacing (GTK_TABLE (table), 0, 2);
	gtk_box_pack_start (GTK_BOX (vbox), table, TRUE, TRUE, DIALOGSPACINGS);
	gtk_widget_show (table);

	text=gtk_text_new(NULL,NULL);
	gtk_text_set_word_wrap(GTK_TEXT(text),TRUE);
	gtk_table_attach (GTK_TABLE (table), text, 0, 1, 0, 1, GTK_EXPAND | GTK_SHRINK | GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
	vscrollbar = gtk_vscrollbar_new (GTK_TEXT (text)->vadj);
	gtk_table_attach (GTK_TABLE (table), vscrollbar, 1, 2, 0, 1, GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
	gtk_widget_show (vscrollbar);
	gtk_text_set_editable(GTK_TEXT(text),FALSE);

	if(aufgebohrt==0)
	{
		sprintf(tmppath,"%s/DISC",path);
		if(DEBUG)
			printf("Searching disclaimer in (1) %s\n",tmppath);
		if(!isGoodFile(tmppath))
		{
			sprintf(tmppath,"%s/DISC",startpath);
			if(DEBUG)
				printf("Searching disclaimer in (2) %s\n",tmppath);
		}
		if(isGoodFile(tmppath))
		{
			file=fopen(tmppath,"r");
			if(file == NULL)
			{
				if(DEBUG)
					printf("Wheres the dammned DISC-File ?\n");
				exit(-1);
			}
			i1=fgetc(file);
			while(i1 != EOF)
			{
				sprintf(c1,"%c",i1);
				gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL,c1,-1);
				i1=fgetc(file);
			}	
			fclose(file);
		}
		else
		{
			gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL,NODISCTEXT,-1);
		}
	}
	else
	{
		sprintf(tmppath,"%s %s",SYS_DIR,FLOPPY);
		if(DEBUG)
			printf("executing %s\n",tmppath);
		file=popen(tmppath,"r");
		if(file == (FILE *)NULL)
		{
			quick_message(ERROR_DIR,2,1);
		}
		else
		{
                        i1=fgetc(file);
                        while(i1 != EOF)
                        {
                                sprintf(c1,"%c",i1);
                                gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL,c1,-1);
                                i1=fgetc(file);
                        }
			pclose(file);
		}
				
	}
	gtk_widget_set_usize(text,DISCH,DISCV);
	gtk_widget_show(text);

        /* OK */
        hbox2=gtk_hbox_new(FALSE,0);
        gtk_box_pack_start(GTK_BOX(vbox),hbox2,FALSE,FALSE,DIALOGSPACINGS);
        gtk_widget_show(hbox2);
        button1=gtk_button_new_with_label(BUTTON_OK);
        gtk_box_pack_start(GTK_BOX(hbox2),button1,TRUE,TRUE,DIALOGSPACINGS);
        gtk_signal_connect(GTK_OBJECT(button1),"clicked",GTK_SIGNAL_FUNC(destroyDisc),NULL);
        gtk_widget_show(button1);

        gtk_widget_show(discWin);

}

int readline(FILE *file, char *string)
{
	int i1;

	i1=fgetc(file);
	while((i1 != 10) & (i1 != EOF))
	{
			*string++=i1;
			i1=fgetc(file);
	}
	*string=(char)NULL;
	if(i1==EOF)
			return(-1);
	else
			return(1);
}
	

void destroyButtons(void)
{
	    	gtk_widget_destroy(leftBox);
		gtk_widget_destroy(middleBox);
		gtk_widget_destroy(rightBox);
		gtk_widget_destroy(downFrame);
		gtk_widget_hide(floppyFrame);
		entryAnz=0;
}

void floppyFunc(GtkWidget *widget,gpointer data )
{
	int ret;

	if(DEBUG)
		printf("floppyFunc: %s\n",(char *)data);
	if(strcmp((char *)data,"del")==0)
	{
		while (gtk_events_pending())
                        gtk_main_iteration();
		quick_message(WAIT,1,0);		
		while (gtk_events_pending())
                        gtk_main_iteration();
		ret=system(SYS_DEL);
		gtk_widget_destroy(dialog);
		while (gtk_events_pending())
                        gtk_main_iteration();
		if(ret!=0)
		{
			quick_message(ERROR_DEL,2,1);	
		}
		while (gtk_events_pending())
                	gtk_main_iteration();
		return;
	}

        if(strcmp((char *)data,"form")==0)
        {
                while (gtk_events_pending())
                        gtk_main_iteration();
                quick_message(WAIT,1,0);
		while (gtk_events_pending())
                        gtk_main_iteration();
                ret=system(SYS_FORMAT);
                /*gtk_widget_destroy(dialog);*/
                while (gtk_events_pending())
                        gtk_main_iteration();
                if(ret!=0)
                {
			gtk_widget_destroy(dialog);
			while (gtk_events_pending())
				gtk_main_iteration();
                        quick_message(ERROR_FORMAT1,2,1);
                }
		else
		{
			ret=system(SYS_DEL);
			while (gtk_events_pending())
				gtk_main_iteration();
			gtk_widget_destroy(dialog);
			if(ret!=0)
			{
				quick_message(ERROR_FORMAT2,2,1);
			}
		}
                while (gtk_events_pending())
                        gtk_main_iteration();
                return;
        }
	if(strcmp((char *)data,"view")==0)
	{
		DiscBox(1);
		return;
	}

	
	quick_message("Function not yet implemented !",3,1);
}

void chDirBut(GtkWidget *widget,gpointer data )
{
	if(DEBUG)
	    printf("chDirBut: %s\n",(char *)data);
	strcat(path,"/");
	strcat(path,(char *)data);
	destroyButtons();
	addDirButtons();
}

void downloadDir(GtkWidget *widget,gpointer data )
{
        char tmpcmd[2*MAXPATH+1];
        int ret;
	quick_message(WAIT,1,0);
	/*gtk_widget_hide(dialog);*/

	if(DEBUG)
	        printf("downloadDir: %s\n",(char *)data);

        sprintf(tmpcmd,"%s -n \"%s/%s/\"* %s",SYS_COPY,path,(char *)data,FLOPPY);
        if(DEBUG)
        printf("executing %s\n",tmpcmd);
        while (gtk_events_pending())
                gtk_main_iteration();
        /*quick_message(WAIT,1,0);*/
	/*gtk_widget_show(dialog);*/
	while (gtk_events_pending())
                gtk_main_iteration();
        ret=system(tmpcmd);
        gtk_widget_destroy(dialog);
        while (gtk_events_pending())
                gtk_main_iteration();
        if(ret!=0)
        {
                quick_message(ERROR_COPY,2,1);
        }
        while (gtk_events_pending())
                gtk_main_iteration();
        return;

}

void imageDir(GtkWidget *widget,gpointer data )
{
	char tmpcmd[2*MAXPATH+1];
	int ret;
	
	quick_message(WAIT,1,0);
        if(DEBUG)
            printf("imageDir: %s\n",(char *)data);
	sprintf(tmpcmd,"%s if=\"%s/%s\" of=/dev/%s",SYS_DD,path,(char *)data,DEV_FLOPPY);
	if(DEBUG)
	printf("executing %s\n",tmpcmd); 
        while (gtk_events_pending())
                gtk_main_iteration();
        /*quick_message(WAIT,1,0);*/
	while (gtk_events_pending())
                gtk_main_iteration();
        ret=system(tmpcmd);
        gtk_widget_destroy(dialog);
        while (gtk_events_pending())
                gtk_main_iteration();
        if(ret!=0)
        {
                quick_message(ERROR_COPY,2,1);
        }
        while (gtk_events_pending())
                gtk_main_iteration();
	return;
}

void execDir(GtkWidget *widget,gpointer data )
{
		FILE *file;
		char tmppath[MAXPATH+1];
		char tmpline[MAXLINE+1];
		int i1,i2;
		
		if(DEBUG)
			printf("execDir: %s\n",(char *)data);
		
		sprintf(tmppath,"%s/EXEC",path);
		file=fopen(tmppath,"r");
		if(file == (FILE *)NULL)
		{
				if(DEBUG)
						printf("Where has my exec gone ???\n");
				exit(-1);
		}
		for(i1=0;i1<(2*atoi((char *)data));i1++)
		{
				i2=readline(file,tmpline);
		}
		fclose(file);
		if(i2 > 0)
		{
				if(DEBUG)
						printf("Executing %s\n",tmpline);
				gtk_widget_hide(mainWindow);
				while (gtk_events_pending())
					gtk_main_iteration();
				chdir(path);
				system(tmpline);
				chdir("-");
				gtk_widget_show(mainWindow);
		}
}

		

void specFunc( GtkWidget *widget,gpointer   data )
{
	char *z1;
	
	if(DEBUG)
		printf("Special-Button: %s\n",(char *)data);

	if(strcmp((char *)data,"back") == 0)	/* Back-Button */
	{
		z1=strrchr(path,'/');
		if(z1 == (char *)NULL)
		{
			if(DEBUG)
				printf("Big bad error while change to dir ..\n");
			exit(-1);
		}
		*z1=(char)NULL;
		if(path[0]==(char)NULL)
		{
			path[0]='/';
			path[1]=(char)NULL;
		}
		destroyButtons();
		addDirButtons();	
		return;
	}
	if(strcmp((char *)data,"men") == 0)    /* Men-Button */
	{
		strcpy(path,startpath);
		destroyButtons();
		addDirButtons();
		return;
	}
	if(strcmp((char *)data,"disc") == 0)    /* Men-Button */
	{
		if(DEBUG)
			printf("Disclaimer\n");
		DiscBox(0);
		return;
	}
		

	if(DEBUG)
		printf("Unknown Funktion !\n");
}	

void addDownFrame(void)
{
	GtkWidget *buttVBox;
	char *z1;
	
        /* Download-Frame */
        downFrame=gtk_frame_new(DOWNTITLE);
        gtk_frame_set_shadow_type(GTK_FRAME(downFrame),FRAMETYPE);
        gtk_widget_show(downFrame);
        gtk_box_pack_start(GTK_BOX(subVBox1),downFrame,FALSE,FALSE,INFRAME);
        buttVBox=gtk_vbox_new(TRUE,BUTTONSPACINGV);
        gtk_container_add(GTK_CONTAINER(downFrame),buttVBox);
        gtk_widget_show(buttVBox);
        buttHBox=gtk_hbox_new(TRUE,BUTTONSPACINGH);
        gtk_box_pack_start(GTK_BOX(buttVBox),buttHBox,FALSE,FALSE,BUTTONSPACINGH);
        gtk_widget_show(buttHBox);
        z1=strrchr(path,'/');
	if(z1 != (char *)NULL)
		gtk_frame_set_label(GTK_FRAME(downFrame),++z1);
	else
		gtk_frame_set_label(GTK_FRAME(downFrame),path);
}

void addDirButtons(void)
{
	    DIR *dir;
		struct dirent *entrys;
		GtkWidget *button;
		int doright;
		char tmppath[MAXPATH+1];

		if(strcmp(path,startpath)==0)
		{
			gtk_widget_set_sensitive(backButton,FALSE);
			gtk_widget_set_sensitive(menButton,FALSE);
		}
		else
		{
			gtk_widget_set_sensitive(backButton,TRUE);
			gtk_widget_set_sensitive(menButton,TRUE);
		}

    		leftBox=gtk_vbox_new(FALSE,0);
		middleBox=gtk_vbox_new(FALSE,0);
		rightBox=gtk_vbox_new(FALSE,0);
		gtk_widget_show(leftBox);
		if(!DIRINONECOLUMN)
		{
			gtk_widget_show(middleBox);
			gtk_widget_show(rightBox);
		}
		addDownFrame();
		gtk_box_pack_start(GTK_BOX(buttHBox),leftBox,TRUE,TRUE,BUTTONSPACINGH);
		gtk_box_pack_start(GTK_BOX(buttHBox),middleBox,TRUE,TRUE,BUTTONSPACINGH);
	 	gtk_box_pack_start(GTK_BOX(buttHBox),rightBox,TRUE,TRUE,BUTTONSPACINGH);
		
		doright=0;

		dir=opendir(path);
		if(dir == (DIR *)NULL)
		{
			printf("Cannot open dir %s: %s\n",path,strerror(errno)); 
		    return;
		}
		if(strcmp(path,startpath)!=0)
		{
        		sprintf(tmppath,"%s/DISC",path);
        		if(DEBUG)
                		printf("Searching for %s\n",tmppath);
        		if(isGoodFile(tmppath))
        		{
                		if(DEBUG)
                        		printf("Image-Dir Disclaimer found !\n");
                			button=gtk_button_new_with_label(UNBEDINGTLESEN);
                        		gtk_box_pack_start(GTK_BOX(leftBox),button,FALSE,FALSE,BUTTONSPACINGV);
                        		doright=1;
                		gtk_signal_connect (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (specFunc), "disc");
                		gtk_widget_show(button);
			}
		}

		entrys=readdir(dir);
		while(entrys != (struct dirent *)NULL)
		{
			if(DEBUG)
		    	printf("Name: %s\n",entrys->d_name);
			strcpy(tmppath,path);
			strcat(tmppath,"/");
			strcat(tmppath,entrys->d_name);
			
			if(isGoodDir(tmppath))
			{
				if((entrys->d_name[0] != '.') && (strstr(entrys->d_name,"DISK") == (char *)NULL))		/* kein special-dir */
				{
					strcpy(names[entryAnz],entrys->d_name);
					button=gtk_button_new_with_label(names[entryAnz]);
					if(doright==0)
					{
						gtk_box_pack_start(GTK_BOX(leftBox),button,FALSE,FALSE,BUTTONSPACINGV);
						if(!DIRINONECOLUMN)
							doright=1;
						else
							doright=0;
					}
					else if(doright==1)
						
					{
						gtk_box_pack_start(GTK_BOX(middleBox),button,FALSE,FALSE,BUTTONSPACINGV);
						doright=2;
					}
					else
					{
						gtk_box_pack_start(GTK_BOX(rightBox),button,FALSE,FALSE,BUTTONSPACINGV);
						doright=0;
					}
					gtk_signal_connect (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (chDirBut), names[entryAnz]);
					gtk_widget_show(button);
					entryAnz++;
					if(entryAnz >= MAXENTRYS)
					{
						if(DEBUG)
							printf("Too many entrys !\n");
						exit(-1);
					}
				}
			}		

	        entrys=readdir(dir);
		}
	    closedir(dir);
		addDownDirButtons(doright);
}

void addDownDirButtons(int doright)
{
        GtkWidget *button;
        char tmppath[MAXPATH+1];
	int i1;

        for(i1=1;i1<MAXENTRYS;i1++)
		{
			sprintf(tmppath,"%s/DISK%i",path,i1);
           	if(isGoodDir(tmppath))
		{
	                gtk_widget_show(middleBox);
			gtk_widget_show(rightBox);
			gtk_widget_show(floppyFrame);
			if(DEBUG)
				printf("Found %s\n",tmppath);
			sprintf(names[entryAnz],"DISK%i",i1);
			sprintf(tmppath,"%s %i",DISKETTE,i1);
            		button=gtk_button_new_with_label(tmppath);
            		if(doright==0)
            		{
	            		gtk_box_pack_start(GTK_BOX(leftBox),button,FALSE,FALSE,BUTTONSPACINGV);
                		doright=1;
            		}
            		else if(doright==1)
           			{
			    		gtk_box_pack_start(GTK_BOX(middleBox),button,FALSE,FALSE,BUTTONSPACINGV);
			    		doright=2;
					}
					else
					{
						gtk_box_pack_start(GTK_BOX(rightBox),button,FALSE,FALSE,BUTTONSPACINGV);
			    		doright=0;
	        		}
	        		gtk_signal_connect (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (downloadDir), names[entryAnz]);
	        		gtk_widget_show(button);
	        		entryAnz++;
	        		if(entryAnz >= MAXENTRYS)
	        		{
	            		if(DEBUG)
		            		printf("Too many entrys !\n");
	            		exit(-1);
	        		}
			}
		}
		addImageButtons(doright);
}
void addImageButtons(int doright)
{
	GtkWidget *button;
    char tmppath[MAXPATH+1];
    int i1;

    for(i1=1;i1<MAXENTRYS;i1++)
    {
		sprintf(tmppath,"%s/DISK%i.IMG",path,i1);
	    if(isGoodFile(tmppath))
	    {
                        gtk_widget_show(middleBox);
                        gtk_widget_show(rightBox);
			gtk_widget_show(floppyFrame);
		    if(DEBUG)
		        printf("Found %s\n",tmppath);
	        sprintf(names[entryAnz],"DISK%i.IMG",i1);
	        sprintf(tmppath,"%s %i",DISKETTE,i1);
	        button=gtk_button_new_with_label(tmppath);
	        if(doright==0)
	        {
		        gtk_box_pack_start(GTK_BOX(leftBox),button,FALSE,FALSE,BUTTONSPACINGV);
	            doright=1;
	        }
	        else if(doright==1)
	        {
		        gtk_box_pack_start(GTK_BOX(middleBox),button,FALSE,FALSE,BUTTONSPACINGV);
	            doright=2;
	        }
	        else
	        {
	            gtk_box_pack_start(GTK_BOX(rightBox),button,FALSE,FALSE,BUTTONSPACINGV);
	            doright=0;
	        }
	        gtk_signal_connect (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (imageDir), names[entryAnz]);
	        gtk_widget_show(button);
	        entryAnz++;
	        if(entryAnz >= MAXENTRYS)
	   	    {
		       if(DEBUG)
		           printf("Too many entrys !\n");
	           exit(-1);
	        }
		}
	}
    addExecButtons(doright);
}

void addExecButtons(int doright)
{
		GtkWidget *button;
		char tmppath[MAXPATH+1];
		int i1,i2;
		char tmpline[MAXLINE+1];
		FILE *file;
		
		i2=1;
		sprintf(tmppath,"%s/EXEC",path);
		file=fopen(tmppath,"r");
		if(file != (FILE *)NULL)
		{
			i1=readline(file,tmpline);
			while(i1 > -1)
			{
					if(DEBUG)
						printf("Titel: %s\n",tmpline);
					sprintf(names[entryAnz],"%i",i2);
					button=gtk_button_new_with_label(tmpline);
					if(doright==0)
					{
							gtk_box_pack_start(GTK_BOX(leftBox),button,FALSE,FALSE,BUTTONSPACINGV);
							if(!DIRINONECOLUMN) 
								doright=1;
							else
								doright=0;
					}
					else if(doright==1)
					{
							gtk_box_pack_start(GTK_BOX(middleBox),button,FALSE,FALSE,BUTTONSPACINGV);
							doright=2;
					}
					else
					{
							gtk_box_pack_start(GTK_BOX(rightBox),button,FALSE,FALSE,BUTTONSPACINGV);
							doright=0;
					}
					gtk_signal_connect (GTK_OBJECT (button), "clicked",GTK_SIGNAL_FUNC (execDir), names[entryAnz]);
					gtk_widget_show(button);
					entryAnz++;
					if(entryAnz >= MAXENTRYS)
					{
							if(DEBUG)
									printf("Too many entrys !\n");
							exit(-1);
					}
					
					i1=readline(file,tmpline);
					i1=readline(file,tmpline);
					i2++;
			}





			fclose(file);
		}
}


int main(int argc, char *argv[])
{
	GtkWidget *mainHBox,*mainVBox;
	GtkWidget *subHBox,*subVBox;
	GtkWidget *subHBox1;
	GtkWidget *specHBox,*specVBox;
	GtkWidget *mainFrame/*,*subFrame*/;
	GtkWidget *specialFrame;
	GtkWidget *discButton;
	GtkWidget *floppyVBox,*floppyHBox;
	GtkWidget *viewButton,*delButton,*formButton;
	char *z1;
	
	gtk_init(&argc, &argv);

	if(argc < 2)
	{
		printf("Usage: %s <path>\n",argv[0]);
		return(0);
	}
	
	strcpy(path,argv[1]);
	entryAnz=0;
	
	/* Fenster erzeugen */
	mainWindow=gtk_window_new(WINDOWTYPE);
	gtk_window_set_title(GTK_WINDOW(mainWindow),TITEL);
	gtk_widget_set_usize(mainWindow,MAINHORZ,MAINVERT);

	/* Hauptrahmen basteln */
	mainVBox=gtk_vbox_new(TRUE,OUTFRAME);
	gtk_widget_show(mainVBox);
	gtk_container_add(GTK_CONTAINER(mainWindow),mainVBox);
	mainHBox=gtk_hbox_new(TRUE,OUTFRAME);
	gtk_widget_show(mainHBox);
	gtk_box_pack_start(GTK_BOX(mainVBox),mainHBox,FALSE,TRUE,OUTFRAME);
	mainFrame=gtk_frame_new(TOPLABEL);
	gtk_frame_set_shadow_type(GTK_FRAME(mainFrame),FRAMETYPE);
	gtk_widget_show(mainFrame);
	gtk_box_pack_start(GTK_BOX(mainHBox),mainFrame,FALSE,TRUE,OUTFRAME);

	/* Unterrahmen basteln */
	subHBox=gtk_hbox_new(TRUE,INFRAME);
	gtk_widget_show(subHBox);
	gtk_container_add(GTK_CONTAINER(mainFrame),subHBox);
    subVBox=gtk_vbox_new(TRUE,INFRAME);
	gtk_widget_show(subVBox);
	gtk_box_pack_start(GTK_BOX(subHBox),subVBox,FALSE,FALSE,INFRAME);
	subFrame=gtk_frame_new(SUBLABEL);
	gtk_frame_set_shadow_type(GTK_FRAME(subFrame),FRAMETYPE);
	gtk_widget_show(subFrame);
	gtk_box_pack_start(GTK_BOX(subVBox),subFrame,FALSE,FALSE,INFRAME);

    subHBox1=gtk_hbox_new(TRUE,INFRAME);
	gtk_widget_show(subHBox1);
	gtk_container_add(GTK_CONTAINER(subFrame),subHBox1);
	subVBox1=gtk_vbox_new(FALSE,INFRAME*0);
	gtk_widget_show(subVBox1);
	gtk_box_pack_start(GTK_BOX(subHBox1),subVBox1,FALSE,FALSE,INFRAME);

	/* Special-Frame */
	specialFrame=gtk_frame_new(SPECTITLE);
	gtk_frame_set_shadow_type(GTK_FRAME(specialFrame),FRAMETYPE);
	gtk_widget_show(specialFrame);
	gtk_box_pack_end(GTK_BOX(subVBox1),specialFrame,FALSE,FALSE,INFRAME);
	specVBox=gtk_vbox_new(TRUE,BUTTONSPACINGV);
	gtk_container_add(GTK_CONTAINER(specialFrame),specVBox);
	gtk_widget_show(specVBox);
	specHBox=gtk_hbox_new(TRUE,BUTTONSPACINGH);
	gtk_box_pack_start(GTK_BOX(specVBox),specHBox,FALSE,FALSE,BUTTONSPACINGH);
	gtk_widget_show(specHBox);
	
	/* Special-Buttons */
	backButton=gtk_button_new_with_label(BACKBUTTON);
	gtk_box_pack_start(GTK_BOX(specHBox),backButton,TRUE,TRUE,BUTTONSPACINGH);
	gtk_widget_show(backButton);
	gtk_signal_connect (GTK_OBJECT (backButton), "clicked",GTK_SIGNAL_FUNC (specFunc), "back");

	menButton=gtk_button_new_with_label(MENBUTTON);
	gtk_box_pack_start(GTK_BOX(specHBox),menButton,TRUE,TRUE,BUTTONSPACINGH);
	gtk_widget_show(menButton);
	gtk_signal_connect (GTK_OBJECT (menButton), "clicked",GTK_SIGNAL_FUNC (specFunc), "men");


	discButton=gtk_button_new_with_label(DISCBUTTON);
	gtk_box_pack_start(GTK_BOX(specHBox),discButton,TRUE,TRUE,BUTTONSPACINGH);
	gtk_widget_show(discButton);
	gtk_signal_connect (GTK_OBJECT (discButton), "clicked",GTK_SIGNAL_FUNC (specFunc), "disc");

    	/* Floppy-Frame */
        floppyFrame=gtk_frame_new(FLOPPYTITLE);
        gtk_frame_set_shadow_type(GTK_FRAME(floppyFrame),FRAMETYPE);
        gtk_box_pack_end(GTK_BOX(subVBox1),floppyFrame,FALSE,FALSE,0);
        floppyVBox=gtk_vbox_new(TRUE,0);
        gtk_container_add(GTK_CONTAINER(floppyFrame),floppyVBox);
        gtk_widget_show(floppyVBox);
        floppyHBox=gtk_hbox_new(TRUE,BUTTONSPACINGH);
        gtk_box_pack_start(GTK_BOX(floppyVBox),floppyHBox,FALSE,FALSE,BUTTONSPACINGH);
        gtk_widget_show(floppyHBox);

	/* Floppy-Buttons */
        viewButton=gtk_button_new_with_label(VIEW);
        gtk_box_pack_start(GTK_BOX(floppyHBox),viewButton,TRUE,TRUE,BUTTONSPACINGH);
        gtk_widget_show(viewButton);
        gtk_signal_connect (GTK_OBJECT (viewButton), "clicked",GTK_SIGNAL_FUNC (floppyFunc), "view");

	delButton=gtk_button_new_with_label(DELBUTTON);
        gtk_box_pack_start(GTK_BOX(floppyHBox),delButton,TRUE,TRUE,BUTTONSPACINGH);
	gtk_widget_show(delButton);
        gtk_signal_connect (GTK_OBJECT (delButton), "clicked",GTK_SIGNAL_FUNC (floppyFunc), "del");

	formButton=gtk_button_new_with_label(FORMBUTTON);
        gtk_box_pack_start(GTK_BOX(floppyHBox),formButton,TRUE,TRUE,BUTTONSPACINGH);
	gtk_widget_show(formButton);
        gtk_signal_connect (GTK_OBJECT (formButton), "clicked",GTK_SIGNAL_FUNC (floppyFunc), "form");

	/* Download-Buttons */

	z1=strrchr(path,'/');
	if(z1 != (char *)NULL)
	{
		z1++;
		if(*z1==(char)NULL)
		{
			z1--;
			*z1=(char)NULL;
		}
	}
	strcpy(startpath,path);

	addDirButtons();

	/* und ab dafuer */
	gtk_signal_connect (GTK_OBJECT (mainWindow), "delete_event",GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
	gtk_signal_connect (GTK_OBJECT (mainWindow), "destroy",GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
	gtk_widget_show(mainWindow);
	gtk_main();


	return(0);
}
